#include <ctype.h>
#include <stdio.h>

#include "nettle/aes.h"

static void
print_block(const uint8_t *label, const uint8_t *block)
{
  unsigned i;
  printf("%s:\n", label);

  for (i = 0; i<AES_BLOCK_SIZE; i++)
    {
      uint8_t octet = block[i];
      
      if (isprint(octet))
	printf("%02x=%c ", octet, octet);

      else
	printf("%02x   ", octet);
    }
  printf("\n");
}

static void
encrypt(struct aes_ctx *ctx,
	const uint8_t *message)
{
  uint8_t block[AES_BLOCK_SIZE];

  print_block("Before encrypt", message);
  aes_encrypt(ctx, AES_BLOCK_SIZE, block, message);

  print_block("After encrypt", block);
  printf("\n");
}

int
main(int argc, char **argv)
{
  struct aes_ctx ctx;
  
  uint8_t key[AES_KEY_SIZE] = { 2,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,
				1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 };

  aes_set_encrypt_key(&ctx, 32, key);

  encrypt(&ctx, "abcdefghijklmno ");
  encrypt(&ctx, "bbcdefghijklmno ");
  encrypt(&ctx, "cbcdefghijklmno ");

  return 0;
}
